<template>
  <div class="category">
    <div v-if="!load && !isSearch" class="wrap q-pa-md q-gutter-sm">
      <div class="flex items-center">
        <router-link v-if="isSearch === false" :to="{name: 'Index'}">
          <q-btn flat icon="arrow_left" label="Назад" />
        </router-link>
        <div v-else>
          <q-btn @click="setIsSearch" flat icon="arrow_left" label="Назад" />
        </div>
        <Breadcrumbs :path="pathName"/>
      </div>
      <div v-for="(category, index) in selectedCategory" :key="category.id_clr">
        <div class="expand p-2">
          <routerLink
            :to="{name: 'LaboratoryResearch', params: {id: category.id_clr, name: category.name_clr}}"
            @click="save(category, category.name_clr, 'LaboratoryResearch', {id: category.id_clr, name: category.name_clr})"
            class="flex"
          >
            <p class="count mr-4">{{category.id_clr}}</p>
            <img src="../assets/images/icons/folder.png" width="20" class="mr-4" alt="">
            <p class="name_clr truncate" :title="category.name_clr">{{category.name_clr}}</p>
            <img @click.prevent="edit(index)"
                 src="../assets/images/icons/pencil-outline.svg"
                 width="16"
                 class="ml-auto mr-4"
                 alt=""
            >
          </routerLink>
        </div>
      </div>
      <div v-for="(category, index) in LaboratoryResearch" :key="category.id_clr">
        <div class="expand p-2">
          <routerLink
            :to="{name: 'ResearchOption', params: {id_clr: category.id_clr, id_lr: category.id_lr}}"
            @click="save(category, category.name_lr, 'ResearchOption', {id_clr: category.id_clr, id_lr: category.id_lr})"
            class="flex"
          >
            <p class="count mr-4">{{category.id_lr}}</p>
            <img src="../assets/images/icons/lab.png" width="16" class="mr-4" alt="">
            <p class="name_clr truncate" :title="category.name_lr">{{category.name_lr}}</p>
            <img @click.prevent="editLab(index)"
                 src="../assets/images/icons/pencil-outline.svg"
                 width="16"
                 class="ml-auto mr-4"
                 alt=""
            >
          </routerLink>
        </div>
      </div>
    </div>
    <div v-else-if="isSearch">
      <router-link to="/" @click.prevent="clearSearch">
        <q-btn flat icon="arrow_left" label="Назад" />
      </router-link>
      <div class="text-center my-6 text-xl opacity-70">Найдено исследований: <span class="text-white px-4 py-1 bg-black rounded-md text-ls">{{searchArr.length}}</span></div>
      <div v-for="(category, index) in searchArr" :key="category.id_clr">
        <div v-if="category" class="expand p-2">
          <router-link
            :to="{name: 'ResearchOption', params: {id: category.id_clr, id_clr: category.id_clr, id_lr: category.id_lr}}"
            @click="save(category, category.name_lr, 'LaboratoryResearch', {id: category.id_clr, name: category.name_clr})"
            class="flex"
          >
            <p class="count mr-4">{{index + 1}}</p>
            <img src="../assets/images/icons/lab.png" width="16" class="mr-4" alt="">
            <p class="name_clr truncate" :title="category.name_lr">{{category.name_lr}}</p>
            <img
              src="../assets/images/icons/pencil-outline.svg"
              width="16"
              class="ml-auto mr-4"
              alt=""
              v-if="1===2"
            >
          </router-link>
        </div>
      </div>
    </div>
    <div v-else class="flex justify-center mt-16">
      <LoadsSpinner v-if="load" large/>
    </div>
    <Modal v-if="modalEdit" @close="modalEdit = false" class="text-white">
      <template #body>
        <div class="text-lg opacity-70 mb-4">Редактирование</div>
        <q-input v-if="editObj.name_clr" autofocus standout v-model="editObj.name_clr" label="Название" class="text-white" />
        <q-input v-else autofocus standout v-model="editObj.name_lr" label="Название" class="text-white" />
        <div class="flex mt-4 justify-end">
          <q-btn color="red" label="Удалить" class="mr-2" />
          <q-btn color="primary" label="Применить" />
        </div>
      </template>
    </Modal>
    <Modal v-if="modalEditLab" @close="modalEditLab = false" background-color="white" class="text-white">
      <template #body>
        <div class="min-w-lg">
          <div class="text-lg opacity-70 mb-4 text-black">Редактирование</div>
          <q-input autofocus v-model="editObj.name_lr" label="Название"/>
          <q-input v-model="editObj.full_name_lr" label="Полное название"/>
          <q-input v-model="editObj.desc_lr" label="Описание"/>
          <div class="edit-modal-switch-wrap text-black">
            <q-toggle v-model="editObj.for_mens" :label="editObj.for_mens && 'Подходит для мужчин' || 'Не подходит для мужчин'"/>
            <q-toggle v-model="editObj.for_womens" :label="editObj.for_womens && 'Подходит для женщин' || 'Не подходит для женщин'"/>
            <q-toggle v-model="editObj.na" :label="editObj.na && 'Исследование активно' || 'Исследование не активно'"/>
          </div>
          <div class="flex mt-4 justify-end">
            <q-btn color="red" label="Удалить" class="mr-2" />
            <q-btn color="primary" label="Применить" />
          </div>
        </div>
      </template>
    </Modal>
  </div>
</template>

<script>
import {computed, onMounted, ref} from "vue";
import { useRouter, useRoute } from 'vue-router'
import axios from "axios";
import LoadsSpinner from "../components/Loads-spinner.vue";
import Modal from "../components/Modal.vue";
import {useStore} from "vuex";
import Breadcrumbs from "../components/Breadcrumbs.vue";

export default {
  name: "Category",
  components: {Breadcrumbs, Modal, LoadsSpinner},
  setup () {
    let store = useStore()
    let route = useRoute()
    let selectedCategory = ref([])
    let editObj = ref({})
    let load = ref(false)
    let modalEdit = ref(false)
    let modalEditLab = ref(false)
    let expandCategory = ref(null)
    let LaboratoryResearch = ref(null)
    let pathName = computed(function () {
      return store.state.path
    });
    let isSearch = computed(function () {
      return store.state.isSearch
    });

    async function init (index) {
      load.value = true
      store.state.path[1] = ''
      await axios.get('http://188.120.231.191:3000/category_lr?id_parent=eq.'+route.params.id)
        .then(res => {
          selectedCategory.value = res.data
        })
      await axios.get('http://188.120.231.191:3000/lab_research?id_clr=eq.'+route.params.id)
        .then(res => {
          LaboratoryResearch.value = res.data
          load.value = false
        })
    }
    function edit (index) {
      editObj.value = selectedCategory.value[index]
      modalEdit.value = true
    }
    function editLab (index) {
      editObj.value = LaboratoryResearch.value[index]
      modalEditLab.value = true
    }
    function save (el, name, path, params) {
      localStorage.setItem('Category', JSON.stringify(el))
      store.commit('SET_PATH', {name, index: 1,path, params})
      if (searchArr.value.length) {
        store.commit('SET_STATE_SEARCH')
      }
    }
    function setIsSearch () {
      store.commit('SET_STATE_SEARCH')
    }
    function clearSearch () {
      store.commit('SEARCH_CLEAR')
    }

    let searchArr = computed(function () {
      return store.state.searchArray
    });
    onMounted(()=> {
      init()
    })
    return {
      router: useRouter(),
      route,
      pathName,
      isSearch,
      editObj,
      modalEdit,
      modalEditLab,
      expandCategory,
      selectedCategory,
      LaboratoryResearch,
      load,
      searchArr,
      setIsSearch,
      clearSearch,
      edit,
      editLab,
      save
    }
  }
}
</script>

<style>
.edit-modal-switch-wrap {
  color: black;
  display: grid;
  grid-template-columns: 1fr 1fr;
  margin-top: 20px;
}
</style>
